Функция Сумма(Значения) Экспорт
	
	Результат = 0;
	Для Каждого Значение Из Значения Цикл
		Результат = Результат + Значение;	
	КонецЦикла;

	Возврат Результат;
	
КонецФункции

Функция Среднее(Значения) Экспорт
	
	Количество = Значения.Количество();
	
	Если Количество = 0 Тогда
		Возврат 0;
	КонецЕсли;
	
	Возврат Сумма(Значения) / Количество;
	
КонецФункции

Функция Минимальное(Значения) Экспорт
	
	МинЗначение = Неопределено;
	Для Каждого Значение Из Значения Цикл
		МинЗначение = ?(МинЗначение = Неопределено, Значение, Мин(МинЗначение, Значение));
	КонецЦикла;
	
	Возврат МинЗначение;
	
КонецФункции

Функция Максимальное(Значения) Экспорт
	
	МаксЗначение = Неопределено;
	Для Каждого Значение Из Значения Цикл
		МаксЗначение = ?(МаксЗначение = Неопределено, Значение, Макс(МаксЗначение, Значение));
	КонецЦикла;
	
	Возврат МаксЗначение;
	
КонецФункции

Функция Дисперсия(Значения) Экспорт
	
	Количество = Значения.Количество();
	
	Если Количество = 0 Тогда
		Возврат Неопределено;
	ИначеЕсли Количество = 1 Тогда
		Возврат 0;
	КонецЕсли;

	Среднее = Среднее(Значения);
	
	Результат = 0;
	Для Инд = 0 По Количество - 1 Цикл	
		Результат = Результат + Pow(Значения[Инд] - Среднее, 2) / (Количество - 1);	
	КонецЦикла;	

	Результат = Результат / Количество;
	
	Возврат Результат;
	
КонецФункции

Функция СтандартноеОтклонение(Значения) Экспорт
	
	Дисперсия = Дисперсия(Значения);
	
	Если Дисперсия = Неопределено Тогда
		Возврат Неопределено;	
	КонецЕсли;
	
	Возврат Sqrt(Дисперсия);
	
КонецФункции

Функция СтандартнаяОшибкаСреднего(СтандартноеОтклонение, Количество) Экспорт

	Если Количество = 0 Тогда
		Возврат 0;
	КонецЕсли;

	Возврат СтандартноеОтклонение / Sqrt(Количество);

КонецФункции

Функция Квартили(УпорядоченныеЗначения) Экспорт
	
	Квартили = Новый Структура();
	Квартили.Вставить("Нижний", НижнийКвартиль(УпорядоченныеЗначения));
	Квартили.Вставить("Медиана", Медиана(УпорядоченныеЗначения));
	Квартили.Вставить("Верхний", ВерхнийКвартиль(УпорядоченныеЗначения));

	Возврат Квартили;

КонецФункции

Функция Медиана(УпорядоченныеЗначения) Экспорт

	Количество = УпорядоченныеЗначения.Количество();

	Если Количество = 0 Тогда
		Возврат 0;
	КонецЕсли;

	Индекс = (Количество - 1) / 2;

	Если Количество % 2 = 0 Тогда
		Возврат 0.5 * (УпорядоченныеЗначения[Индекс] + УпорядоченныеЗначения[Индекс + 1]);
	Иначе
		Возврат УпорядоченныеЗначения[Индекс];
	КонецЕсли;

КонецФункции

Функция НижнийКвартиль(УпорядоченныеЗначения) Экспорт

	Количество = УпорядоченныеЗначения.Количество();

	Если Количество = 0 Тогда
		Возврат 0;
	КонецЕсли;

	Индекс = (Количество + 1) * 0.25;
	Если Не Цел(Индекс) = Индекс Тогда
		Индекс = Цел(Индекс) + 1;
	КонецЕсли;

	Возврат УпорядоченныеЗначения[Индекс - 1];

КонецФункции

Функция ВерхнийКвартиль(УпорядоченныеЗначения) Экспорт

	Количество = УпорядоченныеЗначения.Количество();

	Если Количество = 0 Тогда
		Возврат 0;
	КонецЕсли;

	Индекс = Цел((Количество + 1) * 0.75);

	Возврат УпорядоченныеЗначения[Индекс - 1];

КонецФункции

Функция Квантиль(УпорядоченныеЗначения, Вероятность) Экспорт

	Количество = УпорядоченныеЗначения.Количество();

	Позиция = Вероятность * (Количество - 1);

	ИндексПозиции = Цел(Позиция);
	ДробнаяЧасть = Позиция - ИндексПозиции;

	Если ИндексПозиции < 0 Тогда 
		Возврат УпорядоченныеЗначения[0];
	ИначеЕсли ИндексПозиции >= Количество - 1 Тогда
		Возврат УпорядоченныеЗначения[Количество - 1];
	Иначе
		НижнееЗначение = УпорядоченныеЗначения[ИндексПозиции];
		ВерхнееЗначение = УпорядоченныеЗначения[ИндексПозиции + 1];
		Возврат НижнееЗначение + ДробнаяЧасть * (ВерхнееЗначение - НижнееЗначение);
	КонецЕсли;

КонецФункции

Функция ТолькоЧисла(Значения, ВключаяНеопределено = Ложь) Экспорт

	ТипЧисло = Тип("Число");

	Для Каждого Значение Из Значения Цикл
		
		Если Значение = Неопределено И ВключаяНеопределено Тогда
			Продолжить;
		КонецЕсли;

		Если Не ТипЗнч(Значение) = ТипЧисло Тогда
			Возврат Ложь;
		КонецЕсли;

	КонецЦикла;

	Возврат Истина;

КонецФункции